implemenented 'pkgmgmt' command
[util-vserver.git] / util-vserver / scripts / chcontext
index dded01f..ea42ad8 100755 (executable)
@@ -18,7 +18,7 @@
 
 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
 test -e "$UTIL_VSERVER_VARS" || {
-    echo "Can not find util-vserver installation; aborting..."
+    echo "Can not find util-vserver installation; aborting..." >&2
     exit 1
 }
 . "$UTIL_VSERVER_VARS"
@@ -93,22 +93,12 @@ function showVersion()
 $"chcontext $PACKAGE_VERSION -- allocates/enters a security context
 This program is part of $PACKAGE_STRING
 
-Copyright (C) 2003 Enrico Scholz
+Copyright (C) 2004 Enrico Scholz
 This program is free software; you may redistribute it under the terms of
 the GNU General Public License.  This program has absolutely no warranty."
     exit $1
 }
 
-function cleanup()
-{
-    if test -d "$tmpdir"; then
-       local S="$tmpdir"/socket
-       test ! -S "$S" || $_KEEP_CTX_ALIVE --quit "$S" &>/dev/null
-       rm -rf "$tmpdir"
-    fi
-}
-
-
 $_VSERVER_INFO - FEATURE migrate || exec $_CHCONTEXT_COMPAT "$@"
 
 tmp=$(getopt -o + --long cap:,ctx:,disconnect,domainname:,flag:,hostname:,secure,silent,help,version -n "$0" -- "$@") || exit 1
@@ -120,61 +110,59 @@ OPT_DISCONNECT=
 OPT_FLAGS=()
 OPT_SECURE=
 OPT_SILENT=
+OPT_FAKEINIT=
 
 while true; do
     case "$1" in
        --help)         showHelp $0 ;;
        --version)      showVersion ;;
-       --cap)          OPT_CAPS=( "${OPT_CAPS[@]}" "$1" ); shift;;
-       --ctx)          OPT_CTX=$1; shift;;
-       --disconnect)   OPT_DISCONNECT=1;
-       --domainname)   OPT_DOMAINNAME=$1; shift;;
-       --hostname)     OPT_HOSTNAME=$1;   shift;;
-       --flag)         OPT_FLAGS=( "${OPT_FLAGS[@]}" "$1" ); shift;;
+       --cap)          OPT_CAPS=( "${OPT_CAPS[@]}" "$2" ); shift;;
+       --ctx)          OPT_CTX=$2; shift;;
+       --disconnect)   OPT_DISCONNECT=1;;
+       --domainname)   OPT_DOMAINNAME=$2; shift;;
+       --hostname)     OPT_HOSTNAME=$2;   shift;;
+       --flag)
+           test "$2" = "fakeinit" && \
+               OPT_FAKEINIT=--fakeinit ||
+               OPT_FLAGS=( "${OPT_FLAGS[@]}" "$2" )
+           shift
+           ;;
        --secure)       OPT_SECURE=1;;
        --silent)       OPT_SILENT=1;;
        --)             shift; break;;
-       *)              echo $"chcontext: internal error; arg=='$1'"; exit 1;;
+       *)              echo $"chcontext: internal error; arg=='$1'" >&2; exit 1;;
     esac
     shift
 done
 
-tmpdir=
-tmpdir=$(mktemp -d /tmp/chcontext.XXXXXX)
-trap "cleanup" EXIT
-
-xid=$($_VCONTEXT --create ${OPT_SILENT:+--silent} ${OPT_CTX:+--xid "$OPT_CTX"} -- $_CTX_KEEP_ALIVE --socket "$tmpdir"/socket --timeout 60)
+create_cmd=( $_VCONTEXT --create
+            ${OPT_SILENT:+--silent}
+            ${OPT_CTX:+--xid "$OPT_CTX"} )
+
+chain_cmd=()
+
+test -z "$OPT_DOMAINNAME$OPT_HOSTNAME" || \
+    chain_cmd=( "${chain_cmd[@]}"
+               --
+               $_VUNAME --set --xid self
+               ${OPT_DOMAINNAME:+-t domainname="$OPT_DOMAINNAME"}
+               ${OPT_HOSTNAME:+  -t nodename="$OPT_HOSTNAME"} )
+
+chain_cmd=( "${chain_cmd[@]}"
+               --
+               $_VATTRIBUTE --set
+               ${OPT_CAPS:+--bcap "${OPT_CAPS[@]}"}
+               ${OPT_FLAGS:+--flag "${OPT_FLAGS[@]}"}
+               ${OPT_SECURE:+--secure} )
+               
+migrate_cmd=( $_VCONTEXT
+             ${OPT_SILENT:+--silent}
+             ${OPT_DISCONNECT:+--disconnect}
+             $OPT_FAKEINIT )
+
+"${create_cmd[@]}" "${chain_cmd[@]}" -- \
+    "${migrate_cmd[@]}" --endsetup --migrate-self -- "$@"
 rc=$?
-test "$rc" -ne 255 ||
-    echo $"chcontext: Failed to create the context; aborting..."
-    exit 1
-}
-
-test "$rc" -ne 254 || xid=$OPT_CTX
-test "$xid" || {
-    echo $"chcontext: Failed to determine context xid; aborting..."
-    exit 1
-}
-
-set -e
-test "$rc" -ne 0 || {
-    rm -rf "$tmpdir"
-    unset rc
-}
 
-if test "$rc" -ne 254; then
-    $_VATTRIBUTE --xid "$xid" -s \
-       ${OPT_CAPS:+--cap "${OPT_CAPS[@]}"}
-       ${OPT_FLAGS:+--flag "${OPT_FLAGS[@]}"} \
-       ${OPT_SECURE:+--secure}
-
-    $_VUNAME --xid "$xid" -s \
-       ${OPT_DOMAINNAME:+--domainname "$OPT_DOMAINNAME"} \
-       ${OPT_HOSTNAME:+--nodename "$OPT_HOSTNAME"}
-fi
-
-exec $_VCONTEXT --migrate --xid "$xid" \
-    ${OPT_SILENT:+--silent} \
-    ${OPT_DISCONNECT:+--disconnect} \
-    ${rc:--syncsock "$tmpdir"/socket} \
-    -- "$@"
+test "$rc" -ne 254 || exec "${migrate_cmd[@]}" --xid "$OPT_CTX" --migrate -- "$@"
+exit $rc